//////////////////////////////////////////////////////////////////////////////////
// 
// Desktop Station Parameter Manager
// Copyright(C)'2023- DesktopStation
// 
// Not use for commercial use
// 
// 本ソフトウェアは、上記の著作者によって開発されたものであり、利用には
// ライセンス契約が必要となります。
// 
//////////////////////////////////////////////////////////////////////////////////
//


#ifndef PARAMMANAGER_LIB_H
#define PARAMMANAGER_LIB_H

#include <Arduino.h>


#define PARAMFLAG_OUTBIDICUTOUT	0x00000001

#define PARAMSIZE_DATA			128

#define PARAMTYPE_CRC				0
#define PARAMTYPE_VER				1
#define PARAMTYPE_FIRMWARE			2
#define PARAMTYPE_COUNT_UPDATE		3
#define PARAMTYPE_CUR_LOCOADDR		4
#define PARAMTYPE_CUR_ACCADDR		5
#define PARAMTYPE_CUR_FUNCTION		6
#define PARAMTYPE_CUR_DIRECTION		7
#define PARAMTYPE_MOMENTARY			8
#define PARAMTYPE_BIDICOUT			9
#define PARAMTYPE_FUNCTION			10
#define PARAMTYPE_OCLEVEL			11
#define PARAMTYPE_OVLEVEL			12
#define PARAMTYPE_LVLEVEL			13
#define PARAMTYPE_LOGADDRRANGE		14



/* Defined functions */

class ParamManager
{
	private:
		uint32_t u4_data[PARAMSIZE_DATA];
	
	public:

		uint32_t u4_FlagFunction;	
	
	
		ParamManager();
	
		void Clear();
		void Load();
		void Save();
		void FactoryReset();

		uint32_t GetParameter(uint32_t u4_index);
		void SetParamerter(uint32_t u4_index, uint32_t u4_param_data);

		bool GetFlagBidiCutout();


		
};

#endif
